bd150e6a9b36ae96ed57792f2c7f79c51d21fcae
[arvados.git] / build / run-library.sh
1 #!/bin/bash -xe
2 # Copyright (C) The Arvados Authors. All rights reserved.
3 #
4 # SPDX-License-Identifier: AGPL-3.0
5
6 # A library of functions shared by the various scripts in this directory.
7
8 # This is the timestamp about when we merged changed to include licenses
9 # with Arvados packages.  We use it as a heuristic to add revisions for
10 # older packages.
11 LICENSE_PACKAGE_TS=20151208015500
12
13 if [[ -z "$ARVADOS_BUILDING_VERSION" ]]; then
14     RAILS_PACKAGE_ITERATION=1
15 else
16     RAILS_PACKAGE_ITERATION="$ARVADOS_BUILDING_ITERATION"
17 fi
18
19 debug_echo () {
20     echo "$@" >"$STDOUT_IF_DEBUG"
21 }
22
23 find_python_program() {
24     prog="$1"
25     shift
26     for prog in "$@"; do
27         if "$prog" --version >/dev/null 2>&1; then
28             echo "$prog"
29             return 0
30         fi
31     done
32     cat >&2 <<EOF
33 $helpmessage
34
35 Error: $prog (from Python setuptools module) not found
36
37 EOF
38     exit 1
39 }
40
41 format_last_commit_here() {
42     local format="$1"; shift
43     local dir="${1:-.}"; shift
44     TZ=UTC git log -n1 --first-parent "--format=format:$format" "$dir"
45 }
46
47 version_from_git() {
48     # Output the version being built, or if we're building a
49     # dev/prerelease, output a version number based on the git log for
50     # the given $subdir.
51     local subdir="$1"; shift
52     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
53         echo "$ARVADOS_BUILDING_VERSION"
54         return
55     fi
56
57     local git_ts git_hash
58     declare $(format_last_commit_here "git_ts=%ct git_hash=%h" "$subdir")
59     ARVADOS_BUILDING_VERSION="$($WORKSPACE/build/version-at-commit.sh $git_hash)"
60     echo "$ARVADOS_BUILDING_VERSION"
61 }
62
63 nohash_version_from_git() {
64     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
65         echo "$ARVADOS_BUILDING_VERSION"
66         return
67     fi
68     version_from_git | cut -d. -f1-4
69 }
70
71 timestamp_from_git() {
72     local subdir="$1"; shift
73     format_last_commit_here "%ct" "$subdir"
74 }
75
76 calculate_python_sdk_cwl_package_versions() {
77   python_sdk_ts=$(cd sdk/python && timestamp_from_git)
78   cwl_runner_ts=$(cd sdk/cwl && timestamp_from_git)
79
80   python_sdk_version=$(cd sdk/python && nohash_version_from_git)
81   cwl_runner_version=$(cd sdk/cwl && nohash_version_from_git)
82
83   if [[ $python_sdk_ts -gt $cwl_runner_ts ]]; then
84     cwl_runner_version=$python_sdk_version
85   fi
86 }
87
88 handle_python_package () {
89   # This function assumes the current working directory is the python package directory
90   if [ -n "$(find dist -name "*-$(nohash_version_from_git).tar.gz" -print -quit)" ]; then
91     # This package doesn't need rebuilding.
92     return
93   fi
94   # Make sure only to use sdist - that's the only format pip can deal with (sigh)
95   python setup.py $DASHQ_UNLESS_DEBUG sdist
96 }
97
98 handle_ruby_gem() {
99     local gem_name="$1"; shift
100     local gem_version="$(nohash_version_from_git)"
101     local gem_src_dir="$(pwd)"
102
103     if [[ -n "$ONLY_BUILD" ]] && [[ "$gem_name" != "$ONLY_BUILD" ]] ; then
104         return 0
105     fi
106
107     if ! [[ -e "${gem_name}-${gem_version}.gem" ]]; then
108         find -maxdepth 1 -name "${gem_name}-*.gem" -delete
109
110         # -q appears to be broken in gem version 2.2.2
111         $GEM build "$gem_name.gemspec" $DASHQ_UNLESS_DEBUG >"$STDOUT_IF_DEBUG" 2>"$STDERR_IF_DEBUG"
112     fi
113 }
114
115 calculate_go_package_version() {
116   # $__returnvar has the nameref attribute set, which means it is a reference
117   # to another variable that is passed in as the first argument to this function.
118   # see https://www.gnu.org/software/bash/manual/html_node/Shell-Parameters.html
119   local -n __returnvar="$1"; shift
120   local oldpwd="$PWD"
121
122   cd "$WORKSPACE"
123   go mod download
124
125   # Update the version number and build a new package if the vendor
126   # bundle has changed, or the command imports anything from the
127   # Arvados SDK and the SDK has changed.
128   declare -a checkdirs=(go.mod go.sum)
129   while [ -n "$1" ]; do
130       checkdirs+=("$1")
131       shift
132   done
133   if grep -qr git.arvados.org/arvados .; then
134       checkdirs+=(sdk/go lib)
135   fi
136   local timestamp=0
137   for dir in ${checkdirs[@]}; do
138       cd "$WORKSPACE"
139       ts="$(timestamp_from_git "$dir")"
140       if [[ "$ts" -gt "$timestamp" ]]; then
141           version=$(version_from_git "$dir")
142           timestamp="$ts"
143       fi
144   done
145   cd "$oldpwd"
146   __returnvar="$version"
147 }
148
149 # Usage: package_go_binary services/foo arvados-foo "Compute foo to arbitrary precision" [apache-2.0.txt]
150 package_go_binary() {
151     local src_path="$1"; shift
152     local prog="$1"; shift
153     local description="$1"; shift
154     local license_file="${1:-agpl-3.0.txt}"; shift
155
156     if [[ -n "$ONLY_BUILD" ]] && [[ "$prog" != "$ONLY_BUILD" ]]; then
157       # arvados-workbench depends on arvados-server at build time, so even when
158       # only arvados-workbench is being built, we need to build arvados-server too
159       if [[ "$prog" != "arvados-server" ]] || [[ "$ONLY_BUILD" != "arvados-workbench" ]]; then
160         return 0
161       fi
162     fi
163
164     debug_echo "package_go_binary $src_path as $prog"
165
166     local basename="${src_path##*/}"
167     calculate_go_package_version go_package_version $src_path
168
169     cd $WORKSPACE/packages/$TARGET
170     test_package_presence $prog $go_package_version go
171
172     if [[ "$?" != "0" ]]; then
173       return 1
174     fi
175
176     go get -ldflags "-X git.arvados.org/arvados.git/lib/cmd.version=${go_package_version} -X main.version=${go_package_version}" "git.arvados.org/arvados.git/$src_path"
177
178     local -a switches=()
179     systemd_unit="$WORKSPACE/${src_path}/${prog}.service"
180     if [[ -e "${systemd_unit}" ]]; then
181         switches+=(
182             --after-install "${WORKSPACE}/build/go-python-package-scripts/postinst"
183             --before-remove "${WORKSPACE}/build/go-python-package-scripts/prerm"
184             "${systemd_unit}=/lib/systemd/system/${prog}.service")
185     fi
186     switches+=("$WORKSPACE/${license_file}=/usr/share/doc/$prog/${license_file}")
187
188     fpm_build "${WORKSPACE}/${src_path}" "$GOPATH/bin/${basename}=/usr/bin/${prog}" "${prog}" dir "${go_package_version}" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=${description}" "${switches[@]}"
189 }
190
191 # Usage: package_go_so lib/foo arvados_foo.so arvados-foo "Arvados foo library"
192 package_go_so() {
193     local src_path="$1"; shift
194     local sofile="$1"; shift
195     local pkg="$1"; shift
196     local description="$1"; shift
197
198     debug_echo "package_go_so $src_path as $pkg"
199
200     calculate_go_package_version go_package_version $src_path
201     cd $WORKSPACE/packages/$TARGET
202     test_package_presence $pkg $go_package_version go || return 1
203     cd $WORKSPACE/$src_path
204     go build -buildmode=c-shared -o ${GOPATH}/bin/${sofile}
205     cd $WORKSPACE/packages/$TARGET
206     local -a fpmargs=(
207         "--url=https://arvados.org"
208         "--license=Apache License, Version 2.0"
209         "--description=${description}"
210         "$WORKSPACE/apache-2.0.txt=/usr/share/doc/$pkg/apache-2.0.txt"
211     )
212     if [[ -e "$WORKSPACE/$src_path/pam-configs-arvados" ]]; then
213         fpmargs+=("$WORKSPACE/$src_path/pam-configs-arvados=/usr/share/doc/$pkg/pam-configs-arvados-go")
214     fi
215     if [[ -e "$WORKSPACE/$src_path/README" ]]; then
216         fpmargs+=("$WORKSPACE/$src_path/README=/usr/share/doc/$pkg/README")
217     fi
218     fpm_build "${WORKSPACE}/${src_path}" "$GOPATH/bin/${sofile}=/usr/lib/${sofile}" "${pkg}" dir "${go_package_version}" "${fpmargs[@]}"
219 }
220
221 default_iteration() {
222     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
223         echo "$ARVADOS_BUILDING_ITERATION"
224         return
225     fi
226     local package_name="$1"; shift
227     local package_version="$1"; shift
228     local package_type="$1"; shift
229     local iteration=1
230     if [[ $package_version =~ ^0\.1\.([0-9]{14})(\.|$) ]] && \
231            [[ ${BASH_REMATCH[1]} -le $LICENSE_PACKAGE_TS ]]; then
232         iteration=2
233     fi
234     echo $iteration
235 }
236
237 _build_rails_package_scripts() {
238     local pkgname="$1"; shift
239     local destdir="$1"; shift
240     local srcdir="$RUN_BUILD_PACKAGES_PATH/rails-package-scripts"
241     for scriptname in postinst prerm postrm; do
242         cat "$srcdir/$pkgname.sh" "$srcdir/step2.sh" "$srcdir/$scriptname.sh" \
243             >"$destdir/$scriptname" || return $?
244     done
245 }
246
247 rails_package_version() {
248     local pkgname="$1"; shift
249     local srcdir="$1"; shift
250     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
251         echo "$ARVADOS_BUILDING_VERSION"
252         return
253     fi
254     local version="$(version_from_git)"
255     if [ $pkgname = "arvados-api-server" -o $pkgname = "arvados-workbench" ] ; then
256         calculate_go_package_version version cmd/arvados-server "$srcdir"
257     fi
258     echo $version
259 }
260
261 test_rails_package_presence() {
262   local pkgname="$1"; shift
263   local srcdir="$1"; shift
264
265   if [[ -n "$ONLY_BUILD" ]] && [[ "$pkgname" != "$ONLY_BUILD" ]] ; then
266     return 1
267   fi
268
269   tmppwd=`pwd`
270
271   cd $srcdir
272
273   local version="$(rails_package_version "$pkgname" "$srcdir")"
274
275   cd $tmppwd
276
277   test_package_presence $pkgname $version rails "$RAILS_PACKAGE_ITERATION"
278 }
279
280 get_complete_package_name() {
281   # if the errexit flag is set, unset it until this function returns
282   # otherwise, the shift calls below will abort the program if optional arguments are not supplied
283   if [ -o errexit ]; then
284     set +e
285     trap 'set -e' RETURN
286   fi
287   # $__returnvar has the nameref attribute set, which means it is a reference
288   # to another variable that is passed in as the first argument to this function.
289   # see https://www.gnu.org/software/bash/manual/html_node/Shell-Parameters.html
290   local -n __returnvar="$1"; shift
291   local pkgname="$1"; shift
292   local version="$1"; shift
293   local pkgtype="$1"; shift
294   local iteration="$1"; shift
295   local arch="$1"; shift
296   if [[ "$iteration" == "" ]]; then
297       iteration="$(default_iteration "$pkgname" "$version" "$pkgtype")"
298   fi
299
300   if [[ "$arch" == "" ]]; then
301     rpm_architecture="x86_64"
302     deb_architecture="amd64"
303
304     if [[ "$pkgtype" =~ ^(src)$ ]]; then
305       rpm_architecture="noarch"
306       deb_architecture="all"
307     fi
308
309     # These python packages have binary components
310     if [[ "$pkgname" =~ (ruamel|ciso|pycrypto|pyyaml) ]]; then
311       rpm_architecture="x86_64"
312       deb_architecture="amd64"
313     fi
314   else
315     rpm_architecture=$arch
316     deb_architecture=$arch
317   fi
318
319   local complete_pkgname="${pkgname}_$version${iteration:+-$iteration}_$deb_architecture.deb"
320   if [[ "$FORMAT" == "rpm" ]]; then
321       # rpm packages get iteration 1 if we don't supply one
322       iteration=${iteration:-1}
323       complete_pkgname="$pkgname-$version-${iteration}.$rpm_architecture.rpm"
324   fi
325   __returnvar=${complete_pkgname}
326 }
327
328 # Test if the package already exists, if not return 0, if it does return 1
329 test_package_presence() {
330     local pkgname="$1"; shift
331     local version="$1"; shift
332     local pkgtype="$1"; shift
333     local iteration="$1"; shift
334     local arch="$1"; shift
335     if [[ -n "$ONLY_BUILD" ]] && [[ "$pkgname" != "$ONLY_BUILD" ]] ; then
336       # arvados-workbench depends on arvados-server at build time, so even when
337       # only arvados-workbench is being built, we need to build arvados-server too
338       if [[ "$pkgname" != "arvados-server" ]] || [[ "$ONLY_BUILD" != "arvados-workbench" ]]; then
339         return 1
340       fi
341     fi
342
343     local full_pkgname
344     get_complete_package_name full_pkgname $pkgname $version $pkgtype $iteration $arch
345
346     # See if we can skip building the package, only if it already exists in the
347     # processed/ directory. If so, move it back to the packages directory to make
348     # sure it gets picked up by the test and/or upload steps.
349     # Get the list of packages from the repos
350
351     if [[ "$FORCE_BUILD" == "1" ]]; then
352       echo "Package $full_pkgname build forced with --force-build, building"
353     elif [[ "$FORMAT" == "deb" ]]; then
354       declare -A dd
355       dd[debian9]=stretch
356       dd[debian10]=buster
357       dd[ubuntu1604]=xenial
358       dd[ubuntu1804]=bionic
359       D=${dd[$TARGET]}
360       if [ ${pkgname:0:3} = "lib" ]; then
361         repo_subdir=${pkgname:0:4}
362       else
363         repo_subdir=${pkgname:0:1}
364       fi
365
366       repo_pkg_list=$(curl -s -o - http://apt.arvados.org/pool/${D}-dev/main/${repo_subdir}/${pkgname}/)
367       echo "${repo_pkg_list}" |grep -q ${full_pkgname}
368       if [ $? -eq 0 ] ; then
369         echo "Package $full_pkgname exists upstream, not rebuilding, downloading instead!"
370         curl -s -o "$WORKSPACE/packages/$TARGET/${full_pkgname}" http://apt.arvados.org/pool/${D}-dev/main/${repo_subdir}/${pkgname}/${full_pkgname}
371         return 1
372       elif test -f "$WORKSPACE/packages/$TARGET/processed/${full_pkgname}" ; then
373         echo "Package $full_pkgname exists, not rebuilding!"
374         return 1
375       else
376         echo "Package $full_pkgname not found, building"
377         return 0
378       fi
379     else
380       centos_repo="http://rpm.arvados.org/CentOS/7/dev/x86_64/"
381
382       repo_pkg_list=$(curl -s -o - ${centos_repo})
383       echo ${repo_pkg_list} |grep -q ${full_pkgname}
384       if [ $? -eq 0 ]; then
385         echo "Package $full_pkgname exists upstream, not rebuilding, downloading instead!"
386         curl -s -o "$WORKSPACE/packages/$TARGET/${full_pkgname}" ${centos_repo}${full_pkgname}
387         return 1
388       elif test -f "$WORKSPACE/packages/$TARGET/processed/${full_pkgname}" ; then
389         echo "Package $full_pkgname exists, not rebuilding!"
390         return 1
391       else
392         echo "Package $full_pkgname not found, building"
393         return 0
394       fi
395     fi
396 }
397
398 handle_rails_package() {
399     local pkgname="$1"; shift
400
401     if [[ -n "$ONLY_BUILD" ]] && [[ "$pkgname" != "$ONLY_BUILD" ]] ; then
402         return 0
403     fi
404     local srcdir="$1"; shift
405     cd "$srcdir"
406     local license_path="$1"; shift
407     local version="$(rails_package_version "$pkgname" "$srcdir")"
408     echo "$version" >package-build.version
409     local scripts_dir="$(mktemp --tmpdir -d "$pkgname-XXXXXXXX.scripts")" && \
410     (
411         set -e
412         _build_rails_package_scripts "$pkgname" "$scripts_dir"
413         cd "$srcdir"
414         mkdir -p tmp
415         git rev-parse HEAD >git-commit.version
416         bundle package --all
417     )
418     if [[ 0 != "$?" ]] || ! cd "$WORKSPACE/packages/$TARGET"; then
419         echo "ERROR: $pkgname package prep failed" >&2
420         rm -rf "$scripts_dir"
421         EXITCODE=1
422         return 1
423     fi
424     local railsdir="/var/www/${pkgname%-server}/current"
425     local -a pos_args=("$srcdir/=$railsdir" "$pkgname" dir "$version")
426     local license_arg="$license_path=$railsdir/$(basename "$license_path")"
427     local -a switches=(--after-install "$scripts_dir/postinst"
428                        --before-remove "$scripts_dir/prerm"
429                        --after-remove "$scripts_dir/postrm")
430     if [[ -z "$ARVADOS_BUILDING_VERSION" ]]; then
431         switches+=(--iteration $RAILS_PACKAGE_ITERATION)
432     fi
433     # For some reason fpm excludes need to not start with /.
434     local exclude_root="${railsdir#/}"
435     # .git and packages are for the SSO server, which is built from its
436     # repository root.
437     local -a exclude_list=(.git packages tmp log coverage Capfile\* \
438                            config/deploy\* config/application.yml)
439     # for arvados-workbench, we need to have the (dummy) config/database.yml in the package
440     if  [[ "$pkgname" != "arvados-workbench" ]]; then
441       exclude_list+=('config/database.yml')
442     fi
443     for exclude in ${exclude_list[@]}; do
444         switches+=(-x "$exclude_root/$exclude")
445     done
446     fpm_build "${srcdir}" "${pos_args[@]}" "${switches[@]}" \
447               -x "$exclude_root/vendor/cache-*" \
448               -x "$exclude_root/vendor/bundle" "$@" "$license_arg"
449     rm -rf "$scripts_dir"
450 }
451
452 # Build python packages with a virtualenv built-in
453 fpm_build_virtualenv () {
454   PKG=$1
455   shift
456   PKG_DIR=$1
457   shift
458   PACKAGE_TYPE=${1:-python}
459   shift
460
461   # Set up
462   STDOUT_IF_DEBUG=/dev/null
463   STDERR_IF_DEBUG=/dev/null
464   DASHQ_UNLESS_DEBUG=-q
465   if [[ "$DEBUG" != "0" ]]; then
466       STDOUT_IF_DEBUG=/dev/stdout
467       STDERR_IF_DEBUG=/dev/stderr
468       DASHQ_UNLESS_DEBUG=
469   fi
470   if [[ "$ARVADOS_BUILDING_ITERATION" == "" ]]; then
471     ARVADOS_BUILDING_ITERATION=1
472   fi
473
474   local python=""
475   case "$PACKAGE_TYPE" in
476     python3)
477         python=python3
478         if [[ "$FORMAT" != "rpm" ]]; then
479           pip=pip3
480         else
481           # In CentOS, we use a different mechanism to get the right version of pip
482           pip=pip
483         fi
484         PACKAGE_PREFIX=$PYTHON3_PKG_PREFIX
485         ;;
486   esac
487
488   if [[ "$PKG" != "arvados-docker-cleaner" ]]; then
489     PYTHON_PKG=$PACKAGE_PREFIX-$PKG
490   else
491     # Exception to our package naming convention
492     PYTHON_PKG=$PKG
493   fi
494
495   # arvados-python-client sdist should always be built, to be available
496   # for other dependent packages.
497   if [[ -n "$ONLY_BUILD" ]] && [[ "arvados-python-client" != "$PKG" ]] && [[ "$PYTHON_PKG" != "$ONLY_BUILD" ]] && [[ "$PKG" != "$ONLY_BUILD" ]]; then
498     return 0
499   fi
500
501   cd $WORKSPACE/$PKG_DIR
502
503   rm -rf dist/*
504
505   # Get the latest setuptools
506   if ! $pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'; then
507     echo "Error, unable to upgrade setuptools with"
508     echo "  $pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'"
509     exit 1
510   fi
511   # filter a useless warning (when building the cwltest package) from the stderr output
512   if ! $python setup.py $DASHQ_UNLESS_DEBUG sdist 2> >(grep -v 'warning: no previously-included files matching'); then
513     echo "Error, unable to run $python setup.py sdist for $PKG"
514     exit 1
515   fi
516
517   PACKAGE_PATH=`(cd dist; ls *tar.gz)`
518
519   if [[ "arvados-python-client" == "$PKG" ]]; then
520     PYSDK_PATH=`pwd`/dist/
521   fi
522
523   if [[ -n "$ONLY_BUILD" ]] && [[ "$PYTHON_PKG" != "$ONLY_BUILD" ]] && [[ "$PKG" != "$ONLY_BUILD" ]]; then
524     return 0
525   fi
526
527   # Determine the package version from the generated sdist archive
528   PYTHON_VERSION=${ARVADOS_BUILDING_VERSION:-$(awk '($1 == "Version:"){print $2}' *.egg-info/PKG-INFO)}
529
530   # See if we actually need to build this package; does it exist already?
531   # We can't do this earlier than here, because we need PYTHON_VERSION...
532   # This isn't so bad; the sdist call above is pretty quick compared to
533   # the invocation of virtualenv and fpm, below.
534   if ! test_package_presence "$PYTHON_PKG" $PYTHON_VERSION $PACKAGE_TYPE $ARVADOS_BUILDING_ITERATION; then
535     return 0
536   fi
537
538   echo "Building $FORMAT package for $PKG from $PKG_DIR"
539
540   # Package the sdist in a virtualenv
541   echo "Creating virtualenv..."
542
543   cd dist
544
545   rm -rf build
546   rm -f $PYTHON_PKG*deb
547   echo "virtualenv version: `virtualenv --version`"
548   virtualenv_command="virtualenv --python `which $python` $DASHQ_UNLESS_DEBUG build/usr/share/$python/dist/$PYTHON_PKG"
549
550   if ! $virtualenv_command; then
551     echo "Error, unable to run"
552     echo "  $virtualenv_command"
553     exit 1
554   fi
555
556   if ! build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U pip; then
557     echo "Error, unable to upgrade pip with"
558     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U pip"
559     exit 1
560   fi
561   echo "pip version:        `build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip --version`"
562
563   if ! build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'; then
564     echo "Error, unable to upgrade setuptools with"
565     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'"
566     exit 1
567   fi
568   echo "setuptools version: `build/usr/share/$python/dist/$PYTHON_PKG/bin/$python -c 'import setuptools; print(setuptools.__version__)'`"
569
570   if ! build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U wheel; then
571     echo "Error, unable to upgrade wheel with"
572     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U wheel"
573     exit 1
574   fi
575   echo "wheel version:      `build/usr/share/$python/dist/$PYTHON_PKG/bin/wheel version`"
576
577   if [[ "$TARGET" != "centos7" ]] || [[ "$PYTHON_PKG" != "python-arvados-fuse" ]]; then
578     build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -f $PYSDK_PATH $PACKAGE_PATH
579   else
580     # centos7 needs these special tweaks to install python-arvados-fuse
581     build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG docutils
582     PYCURL_SSL_LIBRARY=nss build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -f $PYSDK_PATH $PACKAGE_PATH
583   fi
584
585   if [[ "$?" != "0" ]]; then
586     echo "Error, unable to run"
587     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -f $PYSDK_PATH $PACKAGE_PATH"
588     exit 1
589   fi
590
591   cd build/usr/share/$python/dist/$PYTHON_PKG/
592
593   # Replace the shebang lines in all python scripts, and handle the activate
594   # scripts too. This is a functional replacement of the 237 line
595   # virtualenv_tools.py script that doesn't work in python3 without serious
596   # patching, minus the parts we don't need (modifying pyc files, etc).
597   for binfile in `ls bin/`; do
598     if ! file --mime bin/$binfile |grep -q binary; then
599       # Not a binary file
600       if [[ "$binfile" =~ ^activate(.csh|.fish|)$ ]]; then
601         # these 'activate' scripts need special treatment
602         sed -i "s/VIRTUAL_ENV=\".*\"/VIRTUAL_ENV=\"\/usr\/share\/$python\/dist\/$PYTHON_PKG\"/" bin/$binfile
603         sed -i "s/VIRTUAL_ENV \".*\"/VIRTUAL_ENV \"\/usr\/share\/$python\/dist\/$PYTHON_PKG\"/" bin/$binfile
604       else
605         if grep -q -E '^#!.*/bin/python\d?' bin/$binfile; then
606           # Replace shebang line
607           sed -i "1 s/^.*$/#!\/usr\/share\/$python\/dist\/$PYTHON_PKG\/bin\/python/" bin/$binfile
608         fi
609       fi
610     fi
611   done
612
613   cd - >$STDOUT_IF_DEBUG
614
615   find build -iname '*.pyc' -exec rm {} \;
616   find build -iname '*.pyo' -exec rm {} \;
617
618   # Finally, generate the package
619   echo "Creating package..."
620
621   declare -a COMMAND_ARR=("fpm" "-s" "dir" "-t" "$FORMAT")
622
623   if [[ "$MAINTAINER" != "" ]]; then
624     COMMAND_ARR+=('--maintainer' "$MAINTAINER")
625   fi
626
627   if [[ "$VENDOR" != "" ]]; then
628     COMMAND_ARR+=('--vendor' "$VENDOR")
629   fi
630
631   COMMAND_ARR+=('--url' 'https://arvados.org')
632
633   # Get description
634   DESCRIPTION=`grep '\sdescription' $WORKSPACE/$PKG_DIR/setup.py|cut -f2 -d=|sed -e "s/[',\\"]//g"`
635   COMMAND_ARR+=('--description' "$DESCRIPTION")
636
637   # Get license string
638   LICENSE_STRING=`grep license $WORKSPACE/$PKG_DIR/setup.py|cut -f2 -d=|sed -e "s/[',\\"]//g"`
639   COMMAND_ARR+=('--license' "$LICENSE_STRING")
640
641   if [[ "$DEBUG" != "0" ]]; then
642     COMMAND_ARR+=('--verbose' '--log' 'info')
643   fi
644
645   COMMAND_ARR+=('-v' "$PYTHON_VERSION")
646   COMMAND_ARR+=('--iteration' "$ARVADOS_BUILDING_ITERATION")
647   COMMAND_ARR+=('-n' "$PYTHON_PKG")
648   COMMAND_ARR+=('-C' "build")
649
650   systemd_unit="$WORKSPACE/$PKG_DIR/$PKG.service"
651   if [[ -e "${systemd_unit}" ]]; then
652     COMMAND_ARR+=('--after-install' "${WORKSPACE}/build/go-python-package-scripts/postinst")
653     COMMAND_ARR+=('--before-remove' "${WORKSPACE}/build/go-python-package-scripts/prerm")
654   fi
655
656   COMMAND_ARR+=('--depends' "$PYTHON3_PACKAGE")
657
658   # avoid warning
659   COMMAND_ARR+=('--deb-no-default-config-files')
660
661   # Append --depends X and other arguments specified by fpm-info.sh in
662   # the package source dir. These are added last so they can override
663   # the arguments added by this script.
664   declare -a fpm_args=()
665   declare -a fpm_depends=()
666
667   fpminfo="$WORKSPACE/$PKG_DIR/fpm-info.sh"
668   if [[ -e "$fpminfo" ]]; then
669     echo "Loading fpm overrides from $fpminfo"
670     if ! source "$fpminfo"; then
671       echo "Error, unable to source $WORKSPACE/$PKG_DIR/fpm-info.sh for $PKG"
672       exit 1
673     fi
674   fi
675
676   for i in "${fpm_depends[@]}"; do
677     COMMAND_ARR+=('--depends' "$i")
678   done
679
680   # make sure the systemd service file ends up in the right place
681   # used by arvados-docker-cleaner
682   if [[ -e "${systemd_unit}" ]]; then
683     COMMAND_ARR+=("usr/share/$python/dist/$PKG/share/doc/$PKG/$PKG.service=/lib/systemd/system/$PKG.service")
684   fi
685
686   COMMAND_ARR+=("${fpm_args[@]}")
687
688   # Make sure to install all our package binaries in /usr/bin.
689   # We have to walk $WORKSPACE/$PKG_DIR/bin rather than
690   # $WORKSPACE/build/usr/share/$python/dist/$PYTHON_PKG/bin/ to get the list
691   # because the latter also includes all the python binaries for the virtualenv.
692   # We have to take the copies of our binaries from the latter directory, though,
693   # because those are the ones we rewrote the shebang line of, above.
694   if [[ -e "$WORKSPACE/$PKG_DIR/bin" ]]; then
695     for binary in `ls $WORKSPACE/$PKG_DIR/bin`; do
696       COMMAND_ARR+=("usr/share/$python/dist/$PYTHON_PKG/bin/$binary=/usr/bin/")
697     done
698   fi
699
700   # the python-arvados-cwl-runner package comes with cwltool, expose that version
701   if [[ -e "$WORKSPACE/$PKG_DIR/dist/build/usr/share/python2.7/dist/python-arvados-cwl-runner/bin/cwltool" ]]; then
702     COMMAND_ARR+=("usr/share/python2.7/dist/python-arvados-cwl-runner/bin/cwltool=/usr/bin/")
703   fi
704
705   COMMAND_ARR+=(".")
706
707   debug_echo -e "\n${COMMAND_ARR[@]}\n"
708
709   FPM_RESULTS=$("${COMMAND_ARR[@]}")
710   FPM_EXIT_CODE=$?
711
712   # if something went wrong and debug is off, print out the fpm command that errored
713   if ! fpm_verify $FPM_EXIT_CODE $FPM_RESULTS && [[ "$STDOUT_IF_DEBUG" == "/dev/null" ]]; then
714     echo "fpm returned an error executing the command:"
715     echo
716     echo -e "\n${COMMAND_ARR[@]}\n"
717   else
718     echo `ls *$FORMAT`
719     mv $WORKSPACE/$PKG_DIR/dist/*$FORMAT $WORKSPACE/packages/$TARGET/
720   fi
721   echo
722 }
723
724 # Build packages for everything
725 fpm_build () {
726   # Source dir where fpm-info.sh (if any) will be found.
727   SRC_DIR=$1
728   shift
729   # The package source.  Depending on the source type, this can be a
730   # path, or the name of the package in an upstream repository (e.g.,
731   # pip).
732   PACKAGE=$1
733   shift
734   # The name of the package to build.
735   PACKAGE_NAME=$1
736   shift
737   # The type of source package.  Passed to fpm -s.  Default "dir".
738   PACKAGE_TYPE=${1:-dir}
739   shift
740   # Optional: the package version number.  Passed to fpm -v.
741   VERSION=$1
742   shift
743
744   if [[ -n "$ONLY_BUILD" ]] && [[ "$PACKAGE_NAME" != "$ONLY_BUILD" ]] && [[ "$PACKAGE" != "$ONLY_BUILD" ]] ; then
745     # arvados-workbench depends on arvados-server at build time, so even when
746     # only arvados-workbench is being built, we need to build arvados-server too
747     if [[ "$PACKAGE_NAME" != "arvados-server" ]] || [[ "$ONLY_BUILD" != "arvados-workbench" ]]; then
748       return 0
749     fi
750   fi
751
752   local default_iteration_value="$(default_iteration "$PACKAGE" "$VERSION" "$PACKAGE_TYPE")"
753
754   declare -a COMMAND_ARR=("fpm" "-s" "$PACKAGE_TYPE" "-t" "$FORMAT")
755   if [ python = "$PACKAGE_TYPE" ] && [ deb = "$FORMAT" ]; then
756       # Dependencies are built from setup.py.  Since setup.py will never
757       # refer to Debian package iterations, it doesn't make sense to
758       # enforce those in the .deb dependencies.
759       COMMAND_ARR+=(--deb-ignore-iteration-in-dependencies)
760   fi
761
762   if [[ "$DEBUG" != "0" ]]; then
763     COMMAND_ARR+=('--verbose' '--log' 'info')
764   fi
765
766   if [[ -n "$PACKAGE_NAME" ]]; then
767     COMMAND_ARR+=('-n' "$PACKAGE_NAME")
768   fi
769
770   if [[ "$MAINTAINER" != "" ]]; then
771     COMMAND_ARR+=('--maintainer' "$MAINTAINER")
772   fi
773
774   if [[ "$VENDOR" != "" ]]; then
775     COMMAND_ARR+=('--vendor' "$VENDOR")
776   fi
777
778   if [[ "$VERSION" != "" ]]; then
779     COMMAND_ARR+=('-v' "$VERSION")
780   fi
781   if [[ -n "$default_iteration_value" ]]; then
782       # We can always add an --iteration here.  If another one is specified in $@,
783       # that will take precedence, as desired.
784       COMMAND_ARR+=(--iteration "$default_iteration_value")
785   fi
786
787   # Append --depends X and other arguments specified by fpm-info.sh in
788   # the package source dir. These are added last so they can override
789   # the arguments added by this script.
790   declare -a fpm_args=()
791   declare -a build_depends=()
792   declare -a fpm_depends=()
793   declare -a fpm_exclude=()
794   if [[ ! -d "$SRC_DIR" ]]; then
795       echo >&2 "BUG: looking in wrong dir for fpm-info.sh: $pkgdir"
796       exit 1
797   fi
798   fpminfo="${SRC_DIR}/fpm-info.sh"
799   if [[ -e "$fpminfo" ]]; then
800       debug_echo "Loading fpm overrides from $fpminfo"
801       source "$fpminfo"
802   fi
803   for pkg in "${build_depends[@]}"; do
804       if [[ $TARGET =~ debian|ubuntu ]]; then
805           pkg_deb=$(ls "$WORKSPACE/packages/$TARGET/$pkg_"*.deb | sort -rg | awk 'NR==1')
806           if [[ -e $pkg_deb ]]; then
807               echo "Installing build_dep $pkg from $pkg_deb"
808               dpkg -i "$pkg_deb"
809           else
810               echo "Attemping to install build_dep $pkg using apt-get"
811               apt-get install -y "$pkg"
812           fi
813           apt-get -y -f install
814       else
815           pkg_rpm=$(ls "$WORKSPACE/packages/$TARGET/$pkg"-[0-9]*.rpm | sort -rg | awk 'NR==1')
816           if [[ -e $pkg_rpm ]]; then
817               echo "Installing build_dep $pkg from $pkg_rpm"
818               rpm -i "$pkg_rpm"
819           else
820               echo "Attemping to install build_dep $pkg"
821               rpm -i "$pkg"
822           fi
823       fi
824   done
825   for i in "${fpm_depends[@]}"; do
826     COMMAND_ARR+=('--depends' "$i")
827   done
828   for i in "${fpm_exclude[@]}"; do
829     COMMAND_ARR+=('--exclude' "$i")
830   done
831
832   COMMAND_ARR+=("${fpm_args[@]}")
833
834   # Append remaining function arguments directly to fpm's command line.
835   for i; do
836     COMMAND_ARR+=("$i")
837   done
838
839   COMMAND_ARR+=("$PACKAGE")
840
841   debug_echo -e "\n${COMMAND_ARR[@]}\n"
842
843   FPM_RESULTS=$("${COMMAND_ARR[@]}")
844   FPM_EXIT_CODE=$?
845
846   fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
847
848   # if something went wrong and debug is off, print out the fpm command that errored
849   if [[ 0 -ne $? ]] && [[ "$STDOUT_IF_DEBUG" == "/dev/null" ]]; then
850     echo -e "\n${COMMAND_ARR[@]}\n"
851   fi
852 }
853
854 # verify build results
855 fpm_verify () {
856   FPM_EXIT_CODE=$1
857   shift
858   FPM_RESULTS=$@
859
860   FPM_PACKAGE_NAME=''
861   if [[ $FPM_RESULTS =~ ([A-Za-z0-9_\.-]*\.)(deb|rpm) ]]; then
862     FPM_PACKAGE_NAME=${BASH_REMATCH[1]}${BASH_REMATCH[2]}
863   fi
864
865   if [[ "$FPM_PACKAGE_NAME" == "" ]]; then
866     EXITCODE=1
867     echo
868     echo "Error: $PACKAGE: Unable to figure out package name from fpm results:"
869     echo
870     echo $FPM_RESULTS
871     echo
872     return 1
873   elif [[ "$FPM_RESULTS" =~ "File already exists" ]]; then
874     echo "Package $FPM_PACKAGE_NAME exists, not rebuilding"
875     return 0
876   elif [[ 0 -ne "$FPM_EXIT_CODE" ]]; then
877     EXITCODE=1
878     echo "Error building package for $1:\n $FPM_RESULTS"
879     return 1
880   fi
881 }
882
883 install_package() {
884   PACKAGES=$@
885   if [[ "$FORMAT" == "deb" ]]; then
886     $SUDO apt-get install $PACKAGES --yes
887   elif [[ "$FORMAT" == "rpm" ]]; then
888     $SUDO yum -q -y install $PACKAGES
889   fi
890 }
891
892 title() {
893     printf '%s %s\n' "=======" "$1"
894 }
895
896 checkexit() {
897     if [[ "$1" != "0" ]]; then
898         title "$2 -- FAILED"
899         failures+=("$2 (`timer`)")
900     else
901         successes+=("$2 (`timer`)")
902     fi
903 }
904
905 timer_reset() {
906     t0=$SECONDS
907 }
908
909 timer() {
910     if [[ -n "$t0" ]]; then
911         echo -n "$(($SECONDS - $t0))s"
912     fi
913 }
914
915 report_outcomes() {
916     for x in "${successes[@]}"
917     do
918         echo "Pass: $x"
919     done
920
921     if [[ ${#failures[@]} == 0 ]]
922     then
923         if [[ ${#successes[@]} != 0 ]]; then
924            echo "All test suites passed."
925         fi
926     else
927         echo "Failures (${#failures[@]}):"
928         for x in "${failures[@]}"
929         do
930             echo "Fail: $x"
931         done
932     fi
933 }